package at.technikumwien.movies;

import at.technikumwien.movies.generated.Movie;

import javax.xml.bind.*;
import javax.xml.transform.stream.StreamSource;
import java.io.File;
import java.util.List;

public class XmlHelper {
    public static void moviesToXml(List<Movie> movies, String filename) throws Exception {
        MovieList movieList = new MovieList(movies);

        JAXBContext jaxbContext = JAXBContext.newInstance(MovieList.class);

        Marshaller marshaller = jaxbContext.createMarshaller();

        marshaller.setProperty(Marshaller.JAXB_ENCODING, "UTF-8");
        marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);

        marshaller.marshal(movieList, System.out);
        marshaller.marshal(movieList, new File(filename));
    }

    public static List<Movie> xmlToMovies(String filename) throws JAXBException {
        JAXBContext jaxbContext = JAXBContext.newInstance(MovieList.class);

        Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();

        StreamSource streamSource = new StreamSource(new File(filename));
        JAXBElement jaxElement = unmarshaller.unmarshal(streamSource, MovieList.class);

        // TODO: Cast here shouldn't be necessary?
        MovieList movieList = (MovieList) jaxElement.getValue();

        return movieList.movies;
    }
}