package at.technikumwien.movies;

import lombok.*;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import java.time.LocalDate;

@Data
@NoArgsConstructor
@AllArgsConstructor

@Entity
@Table(name = "t_actors")
@NamedQueries({
    @NamedQuery(
            name = "Actors.getIdByProperties",
            query = "SELECT a FROM Actor a WHERE " +
                    "a.firstname LIKE :firstname AND " +
                    "a.lastname LIKE :lastname AND " +
                    "a.sex = :sex AND " +
                    "a.birthdate = :birthdate"
    ),
    @NamedQuery(
            name = "Actors.selectAllActors",
            query = "SELECT n FROM Actor n"
    )
})
@XmlRootElement
public class Actor {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @XmlAttribute
    private Long id;

    @Column(length = 100, nullable = false)
    @XmlAttribute
    private String firstname;

    @Column(length = 100, nullable = false)
    @XmlAttribute
    private String lastname;

    @Column(nullable = false)
    @XmlAttribute
    private Sex sex;

    @Column(nullable = false)
    @XmlAttribute
    private LocalDate birthdate;

    public Actor(String firstname, String lastname, Sex sex, LocalDate birthdate) {
        this(null, firstname, lastname, sex, birthdate);
    }
}
