package at.technikumwien.movies;

import javax.annotation.security.DeclareRoles;
import javax.enterprise.context.ApplicationScoped;
import javax.security.enterprise.authentication.mechanism.http.BasicAuthenticationMechanismDefinition;
import javax.security.enterprise.identitystore.DatabaseIdentityStoreDefinition;

@BasicAuthenticationMechanismDefinition(realmName = "MoviesWebApp")
@DeclareRoles({
        "MSRead",
        "MSWrite"
})
@DatabaseIdentityStoreDefinition(
        dataSourceLookup = "java:jboss/datasources/MoviesDS",
        callerQuery = "SELECT password FROM t_user WHERE username = ?",
        groupsQuery = "SELECT r.rolename FROM t_user u " +
                "INNER JOIN t_user_role ur ON u.id = ur.userid " +
                "INNER JOIN t_role r ON ur.roleid = r.id " +
                "WHERE u.username = ?",
        hashAlgorithm = SH2HexPasswordHash.class
)
@ApplicationScoped
public class MovieSecurityConfig {
}
